// BLEDoc.cpp : implementation of the CBLEDoc class
//

#include "stdafx.h"
#include "BLE.h"

#include "BLEDoc.h"
#include "..\\GFile.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBLEDoc

IMPLEMENT_DYNCREATE(CBLEDoc, CDocument)

BEGIN_MESSAGE_MAP(CBLEDoc, CDocument)
	//{{AFX_MSG_MAP(CBLEDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBLEDoc construction/destruction

CBLEDoc::CBLEDoc()
{
	// TODO: add one-time construction code here

}

CBLEDoc::~CBLEDoc()
{
}

BOOL CBLEDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	int i, j;

	for (i = 0; i < MAX_X; i++)
		for (j = 0; j < MAX_Y; j++) {
			m_map[i][j] = 0;
			m_mapmrch[i][j] = -1;
		}

	
	m_map[0][1] =  2;
	m_map[15][1] = 4;
	m_map[0][11] = 6;
	m_map[15][11] = 8;

	for (i = 1; i < 15; i++) {
		m_map[i][1] = 3;
		m_map[i][11] = 7;
	}
	for (j = 2; j < 11; j++) {
		m_map[0][j] = 1;
		m_map[15][j] = 5;
	}

	for (i = 1; i < 15; i++)
		for (j = 2; j < 11; j++)
			if (rand()%2) m_map[i][j] = 11;

	m_podklad = 0;
	m_deadmach = false;
	m_x = 16;
	m_y = 12;

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CBLEDoc serialization

void CBLEDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBLEDoc diagnostics

#ifdef _DEBUG
void CBLEDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBLEDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBLEDoc commands

BOOL CBLEDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;

	st_map map;
	GFile::LoadMap(&map, lpszPathName);
	memcpy(m_map, map.map, MAX_X*MAX_Y*sizeof(int));
	m_deadmach = map.deadmach;
	m_podklad  = map.podklad ;
	m_x        = map.x       ;
	m_y        = map.y       ;
	memcpy(m_mapmrch, map.mapmrch, MAX_X*MAX_Y*sizeof(int));
	
	if (m_x < 0) m_x = 0;
	if (m_y < 0) m_y = 0;

	return TRUE;
}

BOOL CBLEDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CDocument::OnSaveDocument(lpszPathName);

	st_map map;
	memcpy(map.map, m_map, MAX_X*MAX_Y*sizeof(int));
	map.deadmach = m_deadmach;
	map.podklad  = m_podklad ;
	map.x        = m_x       ;
	map.y        = m_y       ;
	memcpy(map.mapmrch, m_mapmrch, MAX_X*MAX_Y*sizeof(int));

	GFile::SaveMap(&map, lpszPathName);
	

	return TRUE; //
}
